"
 Copyright (c) 2007-2010 Jan Vrany
 Copyright (c) 2009-2010 eXept Software AG

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:libsvn' }"

"{ NameSpace: SVN }"

AbstractSettingsApplication subclass:#ConfigurationApp
	instanceVariableNames:'currentProfileHolder availableProfilesHolder svnConfigurations2
		svnCurrentConfiguration configurationSelectedHolder
		newConfigurationCount'
	classVariableNames:''
	poolDictionaries:''
	category:'SVN-UI-Configuration'
!

!ConfigurationApp class methodsFor:'documentation'!

copyright
"
 Copyright (c) 2007-2010 Jan Vrany
 Copyright (c) 2009-2010 eXept Software AG

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

"
! !

!ConfigurationApp class methodsFor:'help specs'!

flyByHelpSpec

    <resource: #help>
    
    ^self helpSpec

    "Created: / 26-05-2008 / 14:25:31 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

helpSpec
    "This resource specification was automatically generated
     by the UIHelpTool of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIHelpTool may not be able to read the specification."

    "
     UIHelpTool openOnClass:SVN::SettingsApp    
    "

    <resource: #help>

    ^ super helpSpec addPairsFrom:#(

#Package
''

)

    "Modified: / 26-05-2008 / 14:24:15 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!ConfigurationApp class methodsFor:'image specs'!

defaultIcon

    ^SVN::IconLibrary svn_wizban2 magnifiedTo: 24@24

    "Created: / 26-05-2008 / 14:55:55 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

svnIcon
    ^ IconLibrary svn_wizban

    "Created: / 24-05-2008 / 01:44:19 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!ConfigurationApp class methodsFor:'interface opening'!

open    

    | settingsApp |

    settingsApp := SettingsDialog new.
    settingsApp addApplClass:self fullName
                withName:'Subversion'.
    settingsApp showRoot: false.
    settingsApp selectedItem value:
        (settingsApp applicationList root children anyOne).
    settingsApp open.

    "Created: / 26-05-2008 / 12:17:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 27-02-2010 / 17:07:36 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!ConfigurationApp class methodsFor:'interface specs'!

basicTabSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:SVN::ConfigurationApp andSelector:#basicTabSpec
     SVN::ConfigurationApp new openInterface:#basicTabSpec
    "

    <resource: #canvas>

    ^ 
     #(FullSpec
        name: basicTabSpec
        window: 
       (WindowSpec
          label: 'Basic Settings'
          name: 'Basic Settings'
          bounds: (Rectangle 0 0 611 309)
        )
        component: 
       (SpecCollection
          collection: (
           (VerticalPanelViewSpec
              name: 'GeneralSettingsPanel'
              layout: (LayoutFrame 0 0 0 0 0 1 0 1)
              horizontalLayout: fit
              verticalLayout: top
              horizontalSpace: 3
              verticalSpace: 3
              component: 
             (SpecCollection
                collection: (
                 (MultiColumnPanelViewSpec
                    name: 'Grid'
                    horizontalLayout: fit
                    verticalLayout: top
                    columnWidths: 
                   (OrderedCollection
                      0.25 0.7
                    )
                    component: 
                   (SpecCollection
                      collection: (
                       (LabelSpec
                          label: 'Working Copy:'
                          name: 'WorkingCopyBaseLabel'
                          translateLabel: true
                          adjust: leftRight
                          extent: (Point 154 25)
                        )
                       (FilenameInputFieldSpec
                          name: 'WorkingCopyBase'
                          enableChannel: svnEnabled
                          model: workingCopyBaseAspect
                          modifiedChannel: modifiedChannel
                          acceptOnPointerLeave: false
                          extent: (Point 454 25)
                          viewClassName: 'FilenameWidgetWithHistory'
                          postBuildCallback: postBuildWorkingCopyField:
                        )
                       )
                     
                    )
                    useDefaultExtent: true
                  )
                 (DividerSpec
                    name: 'Separator'
                    extent: (Point 611 5)
                  )
                 (CheckBoxSpec
                    label: 'Verbose (Traces svn commands to Transcript)'
                    name: 'Verbose'
                    enableChannel: svnEnabled
                    model: svnVerbose
                    translateLabel: true
                    useDefaultExtent: true
                  )
                 )
               
              )
            )
           )
         
        )
      )
!

profilesTabSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:SVN::ConfigurationApp andSelector:#profilesTabSpec
     SVN::ConfigurationApp new openInterface:#profilesTabSpec
    "

    <resource: #canvas>

    ^ 
     #(FullSpec
        name: profilesTabSpec
        window: 
       (WindowSpec
          label: 'Profiles'
          name: 'Profiles'
          min: (Point 10 10)
          bounds: (Rectangle 0 0 782 552)
        )
        component: 
       (SpecCollection
          collection: (
           (LabelSpec
              label: 'Current profile:'
              name: 'CurrentProfileLabel'
              layout: (LayoutFrame 0 0 0 0 102 0 30 0)
              translateLabel: true
              adjust: leftRight
              useDynamicPreferredWidth: true
              usePreferredWidth: true
            )
           (ComboListSpec
              name: 'CurrentConfiguration'
              layout: (LayoutFrame 103 0 3 0 0 1 28 0)
              model: svnCurrentConfiguration
              comboList: svnConfigurations2
              useIndex: false
            )
           (DividerSpec
              name: 'Separator1'
              layout: (LayoutFrame 0 0 30 0 0 1 35 0)
            )
           (LabelSpec
              label: 'Available profiles:'
              name: 'AvailableProfiles'
              layout: (LayoutFrame 0 0 35 0 0 1 65 0)
              translateLabel: true
              adjust: left
            )
           (SelectionInListModelViewSpec
              name: 'ProfileList'
              layout: (LayoutFrame 0 0 65 0 -100 1 0 1)
              model: selectedProfileIndexHolder
              hasHorizontalScrollBar: true
              hasVerticalScrollBar: true
              listModel: svnConfigurations2
              highlightMode: line
              doubleClickSelector: doConfigurationEdit
            )
           (VerticalPanelViewSpec
              name: 'Buttons1'
              layout: (LayoutFrame -95 1 65 0 0 1 0 0.7)
              horizontalLayout: fit
              verticalLayout: top
              horizontalSpace: 5
              verticalSpace: 3
              component: 
             (SpecCollection
                collection: (
                 (ActionButtonSpec
                    label: 'Add'
                    name: 'ButtonAdd'
                    translateLabel: true
                    model: doConfigurationAdd
                    extent: (Point 95 22)
                  )
                 (ActionButtonSpec
                    label: 'Remove'
                    name: 'ButtonRemove'
                    translateLabel: true
                    model: doConfigurationRemove
                    enableChannel: configurationSelectedHolder
                    extent: (Point 95 22)
                  )
                 (ActionButtonSpec
                    label: 'Edit'
                    name: 'ButtonEdit'
                    translateLabel: true
                    model: doConfigurationEdit
                    enableChannel: configurationSelectedHolder
                    extent: (Point 95 22)
                  )
                 )
               
              )
            )
           (VerticalPanelViewSpec
              name: 'Buttons2'
              layout: (LayoutFrame -95 1 0 0.7 0 1 0 1)
              horizontalLayout: fit
              verticalLayout: bottom
              horizontalSpace: 5
              verticalSpace: 3
              component: 
             (SpecCollection
                collection: (
                 (ActionButtonSpec
                    label: 'Export'
                    name: 'Button2'
                    translateLabel: true
                    model: doConfigurationExport
                    enableChannel: configurationSelectedHolder
                    extent: (Point 95 22)
                  )
                 (ActionButtonSpec
                    label: 'Import'
                    name: 'Button3'
                    translateLabel: true
                    model: doConfigurationImport
                    extent: (Point 95 22)
                  )
                 )
               
              )
            )
           )
         
        )
      )
!

windowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:SVN::ConfigurationApp andSelector:#windowSpec
     SVN::ConfigurationApp new openInterface:#windowSpec
     SVN::ConfigurationApp open
    "

    <resource: #canvas>

    ^ 
     #(FullSpec
        name: windowSpec
        window: 
       (WindowSpec
          label: 'SubVersion Settings'
          name: 'SubVersion Settings'
          min: (Point 10 10)
          bounds: (Rectangle 0 0 695 627)
        )
        component: 
       (SpecCollection
          collection: (
           (LabelSpec
              label: ' Subversion Settings'
              name: 'SubVersionSettingsTitle'
              layout: (LayoutFrame 0 0 0 0 0 1 66 0)
              style: (FontDescription helvetica medium roman 18 #'iso10646-1')
              backgroundColor: (Color 100.0 100.0 100.0)
              translateLabel: true
              adjust: left
            )
           (LabelSpec
              label: 'Icon'
              name: 'SubVersionIcon'
              layout: (LayoutFrame -75 1 0 0 0 1 66 0)
              hasCharacterOrientedLabel: false
              backgroundColor: (Color 100.0 100.0 100.0)
              translateLabel: true
              labelChannel: svnIcon
            )
           (VerticalPanelViewSpec
              name: 'Controls'
              layout: (LayoutFrame 0 0 70 0 0 1 0 1)
              horizontalLayout: fit
              verticalLayout: topFit
              horizontalSpace: 3
              verticalSpace: 3
              component: 
             (SpecCollection
                collection: (
                 (HorizontalPanelViewSpec
                    name: 'SVNEnabledAndResetPanel'
                    horizontalLayout: rightSpaceFit
                    verticalLayout: fit
                    horizontalSpace: 0
                    verticalSpace: 3
                    component: 
                   (SpecCollection
                      collection: (
                       (CheckBoxSpec
                          label: 'Enable SubVersion Manager'
                          name: 'Enabled'
                          model: svnEnabled
                          translateLabel: true
                          extent: (Point 521 30)
                        )
                       (ActionButtonSpec
                          label: 'Reset cached repositories'
                          name: 'ResetCachedRepositoriesButton'
                          translateLabel: true
                          model: resetCachedRepositories
                          enableChannel: svnEnabled
                          extent: (Point 175 30)
                        )
                       )
                     
                    )
                    extent: (Point 695 30)
                  )
                 (NoteBookViewSpec
                    name: 'NoteBook'
                    menu: tabList
                    useDefaultExtent: true
                  )
                 )
               
              )
            )
           )
         
        )
      )
! !

!ConfigurationApp class methodsFor:'list specs'!

tabList
    "This resource specification was automatically generated
     by the TabListEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the TabListEditor may not be able to read the specification."

    "
     TabListEditor new openOnClass: self andSelector:#tabList
    "

    <resource: #tabList>

    ^     #(
       (TabItem
          label: 'Profiles'
          minorKey: profilesTabSpec
          createNewBuilder: false
        )
       (TabItem
          label: 'Settings'
          minorKey: basicTabSpec
          createNewBuilder: false
        )
       )
     
      collect:[:aTab| TabItem new fromLiteralArrayEncoding:aTab ]
! !

!ConfigurationApp class methodsFor:'queries'!

managerTypeName

    ^SVNSourceCodeManager managerTypeName

    "Created: / 07-07-2011 / 23:13:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!ConfigurationApp class methodsFor:'tableColumns specs'!

configurationListColumns
    "This resource specification was automatically generated
     by the DataSetBuilder of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the DataSetBuilder may not be able to read the specification."

    "
     DataSetBuilder new openOnClass:SVN::SettingsApp andSelector:#configurationListColumns
    "

    <resource: #tableColumns>

    ^#(
      (DataSetColumnSpec
         activeHelpKey: ''
         labelButtonType: Button
         rendererType: rowSelector
         showRowSeparator: false
         showColSeparator: false
       )
      (DataSetColumnSpec
         label: 'Package'
         labelAlignment: left
         activeHelpKey: ''
         labelButtonType: Button
         model: package
         canSelect: false
         showRowSeparator: false
         showColSeparator: false
       )
      (DataSetColumnSpec
         label: 'URL'
         labelAlignment: left
         activeHelpKey: ''
         labelButtonType: Button
         model: urlString
         canSelect: false
         showRowSeparator: false
         showColSeparator: false
       )
      )

    "Modified: / 16-08-2009 / 17:28:28 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!ConfigurationApp methodsFor:'accessing'!

repositoryConfiguration

    ^self repositoryConfigurationAspect value

    "Created: / 26-05-2008 / 12:04:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

repositoryConfiguration: anObject

    self repositoryConfigurationAspect value: anObject

    "Created: / 26-05-2008 / 12:12:17 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

repositoryConfigurationList

    ^self repositoryConfigurationListAspect value

    "Created: / 26-05-2008 / 12:05:01 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

repositoryManager

    ^RepositoryManager current

    "Created: / 26-05-2008 / 10:46:30 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

selectedConfiguration

    | index config |
    (index := self selectedProfileIndexHolder value) ifNil:[^self].
    config := self svnConfigurations2 value at: index.
    ^config

    "Created: / 25-03-2010 / 16:44:58 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

workingCopyBase

    ^self workingCopyBaseAspect value

    "Created: / 26-05-2008 / 13:15:22 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!ConfigurationApp methodsFor:'actions'!

doConfigurationAdd
    <resource: #uiCallback>
    |config|

    config := SVN::Configuration new.
    config name:((newConfigurationCount == 0) 
                ifTrue:[ '<new profile>' ]
                ifFalse:[ '<new profile %1>' bindWith:newConfigurationCount ]).
    (self doConfigurationEdit:config) ifTrue:[
        self doConfigurationAdd:config.
        newConfigurationCount := newConfigurationCount + 1.
    ].

    "Modified: / 26-03-2010 / 20:34:50 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

doConfigurationAdd:config 
    self svnConfigurations2 
        value:(self svnConfigurations2 value copyWith:config).
    self selectedProfileIndexHolder value:self svnConfigurations2 value size.
    self updateModifiedChannel.

    "Modified: / 26-03-2010 / 20:38:55 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

doConfigurationEdit

    | config |

    (config := self selectedConfiguration) ifNil:[^self].
    self doConfigurationEdit: config.

    "Modified: / 25-03-2010 / 16:45:38 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

doConfigurationEdit: config  

    ^(ConfigurationDialog openOn: config) 
        ifTrue:
            [svnCurrentConfiguration changed.
            self updateModifiedChannel.
            true]
        ifFalse:
            [false]

    "Created: / 25-03-2010 / 08:28:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 25-03-2010 / 16:42:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

doConfigurationExport

    | config name s |
    config := self selectedConfiguration.
    name := (Smalltalk::Dialog 
                requestFileName:'Enter a filename' 
                default: (config name) , '.rc'
                ifFail:[^self]) asFilename.
    [s := name writeStream.
     config literalArrayEncoding storeOn: s]
        ensure:[s close].

    "Modified: / 26-03-2010 / 20:22:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

doConfigurationImport

    | config name |
    config := self selectedConfiguration.
    name := (Smalltalk::Dialog 
                requestFileName:'Enter a filename' 
                pattern: '*.rc').
    name isNilOrEmptyCollection ifTrue:[^self].
    name := name asFilename.
    [
        config := Compiler evaluate: name contents asString.
        config := config decodeAsLiteralArray.
        (config isKindOf: SVN::Configuration) ifFalse:
            [self error:'File does not contain serialized SVN configuration'].
        self doConfigurationAdd: config.
    ] on: Smalltalk::Error do:
    [:ex|
        Smalltalk::Dialog warn: 
            ('Failed to read profile from %1' bindWith: name asString).
        ex pass.
    ]

    "Modified: / 26-03-2010 / 20:36:46 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

doConfigurationRemove

    | config |

    (config := self selectedConfiguration) ifNil:[^self].
    self svnConfigurations2 value: (self svnConfigurations2 value copyWithout: config).
    self updateModifiedChannel.

    "Modified: / 26-03-2010 / 20:39:07 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

postBuildWorkingCopyField: aView

    aView 
        directoriesOnly: true;
        historyList: Smalltalk packagePath

    "Modified: / 27-11-2009 / 13:02:20 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

resetCachedRepositories

    RepositoryManager reset

    "Created: / 20-03-2009 / 10:30:14 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 02-04-2009 / 22:53:19 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!ConfigurationApp methodsFor:'aspects'!

aspects
    ^ #( #svnEnabled #svnVerbose svnCurrentConfiguration)

    "Modified: / 31-03-2011 / 14:00:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

configurationSelectedHolder
    "return/create the valueHolder 'repositorySelectedHolder'"

    configurationSelectedHolder isNil ifTrue:[
        configurationSelectedHolder := 
            BlockValue 
                with:[:model|model value notNil and:[model value ~= 0]]
                argument: self selectedProfileIndexHolder
    ].
    ^ configurationSelectedHolder

    "Created: / 25-03-2010 / 08:27:16 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

selectedProfileIndexHolder

    |holder|

    (holder := builder bindingAt:#selectedProfileIndexHolder) isNil ifTrue:[
        holder := ValueHolder new.
        builder aspectAt:#selectedProfileIndexHolder put:holder.
    ].
    ^ holder.

    "Created: / 09-03-2010 / 13:30:45 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

svnConfigurations2
    <resource: #uiAspect>

    "automatically generated by UIPainter ..."

    "*** the code below creates a default model when invoked."
    "*** (which may not be the one you wanted)"
    "*** Please change as required and accept it in the browser."
    "*** (and replace this comment by something more useful ;-)"

    svnConfigurations2 isNil ifTrue:[
        svnConfigurations2 := ValueHolder new.
"/ if your app needs to be notified of changes, uncomment one of the lines below:
"/       svnConfigurations2 addDependent:self.
"/       svnConfigurations2 onChangeSend:#svnConfigurations2Changed to:self.
    ].
    ^ svnConfigurations2.
!

svnCurrentConfiguration
    ^self settingsAspectFor: #svnCurrentConfiguration

    "Modified: / 31-03-2011 / 14:01:56 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

svnEnabled

    ^self settingsAspectFor: #svnEnabled

    "Created: / 25-05-2009 / 18:48:17 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

svnIcon

    ^self class svnIcon

    "Created: / 24-05-2008 / 01:44:11 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

svnVerbose

    ^self settingsAspectFor: #svnVerbose

    "Created: / 25-05-2009 / 19:10:14 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

tabList
    "Generated by the TabListEditor"

    |list|

    (list := builder bindingAt:#tabList) isNil ifTrue:[
        builder aspectAt:#tabList put:(list := self class tabList).
    ].
    ^ list
!

workingCopyBaseAspect

    |holder|

    (holder := builder bindingAt:#workingCopyBaseAspect) ifNil:[
        holder := self repositoryManager workingCopyBase asValue.
        holder onChangeSend:#updateModifiedChannel to:self.
        builder aspectAt:#workingCopyBaseAspect put: holder
    ].
    ^ holder.

    "Created: / 26-05-2008 / 10:41:42 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 25-05-2009 / 18:50:26 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!ConfigurationApp methodsFor:'helpers'!

settingsAspectFor: settingName

    |holder|

    self createBuilder.

    (holder := builder bindingAt:settingName) ifNil:
            [holder := (currentUserPrefs perform: settingName asSymbol)
                            asValue.
            holder onChangeSend:#updateModifiedChannel to:self.
            builder aspectAt:settingName put:holder
    ].
    ^ holder.

    "Created: / 25-05-2009 / 18:43:42 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!ConfigurationApp methodsFor:'initialization'!

initialize

    super initialize.
    newConfigurationCount := 1.

    "Created: / 25-03-2010 / 08:31:33 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!ConfigurationApp methodsFor:'protocol'!

basicReadSettings

    | confs |

    self readAspects: self aspects from:currentUserPrefs.
    self svnConfigurations2 value: (confs := SVN::Configuration configurations deepCopy asList).

    "Created: / 19-04-2008 / 09:42:59 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 25-05-2009 / 19:05:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 31-03-2011 / 14:17:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

basicSaveSettings

    self writeAspects: self aspects to:currentUserPrefs.
    SVN::Configuration configurations: self svnConfigurations2 value.
    self resetCachedRepositories

    "Created: / 19-04-2008 / 09:42:59 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 25-05-2009 / 19:06:45 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 31-03-2011 / 14:11:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

helpFilename
    "subclasses must return the relative name of a helpFile
     in the doc/online/<language>/help directory.
     Or nil, if no help is available."

    ^nil

    "Created: / 19-04-2008 / 09:42:59 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 26-05-2008 / 13:12:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!ConfigurationApp methodsFor:'queries'!

hasUnsavedChanges
    (self hasChangedAspectIn:self aspects asComparedTo:currentUserPrefs)
        ifTrue:[^true].
    SVN::Configuration configurations asArray = svnConfigurations2 value asArray 
        ifFalse:[^true].
    ^ false

    "Created: / 28-05-2008 / 07:33:26 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 19-08-2009 / 12:07:01 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 31-03-2011 / 14:11:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!ConfigurationApp class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
!

version_SVN
    ^ 'Id: SVN__ConfigurationApp.st 354 2011-07-07 22:28:54Z vranyj1 '
! !
